import szgpov0730 as szgpov
from PySZG import *
from OpenGL.GL import *
from OpenGL.GLU import *
import os
import sys
import math


__coordTransMatrix = arMatrix4( (1,0,0,0,0,1,0,0,0,0,-1,0,0,0,0,1) )

# Convert a matrix from syzygy to povray coordinates
def ar_szgMatrixToPOV( szgMatrix ):
   return __coordTransMatrix * szgMatrix * __coordTransMatrix

# Convert an arMatrix4 in povray coords to a povray matrix tuple
# (i.e. suitable for a python template of the povray 'matrix'
# command).
def ar_povMatrixToTuple( povMatrix ):
   return tuple([povMatrix[i] for i in [0,1,2,4,5,6,8,9,10,12,13,14]])

class POVSceneFromTemplate(object):
  def __init__(self):
    object.__init__(self)
    self.wandMatrixTuple = (1,0,0,0,1,0,0,0,1,1,4,1)
  def update( self,app ):
    self.wandMatrixTuple = ar_povMatrixToTuple( app.getMatrix(1) )
  def getState(self):
    return self.wandMatrixTuple
  def setState( self, stateTuple ):
    self.wandMatrixTuple = stateTuple[0:]
  def __call__(self):
    return[\
r"""#declare szgpovCam = true;
#include "szgpovscn.pov"
// Syzygy wand
//box {<-.1,-.1,0>,<.1,.1,5> pigment {color rgb 1} matrix <%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f>}
""" % self.wandMatrixTuple, ]


if __name__=='__main__':
  import sys
  app = szgpov.POVApp( scene=POVSceneFromTemplate() )
  if not app.init( sys.argv ):
    raise RuntimeError, 'app init failed.'
  if not app.start():
    raise RuntimeError, 'app start failed.'

